GNU bug report logs - #51661
29.0.50; What is "interactive Lisp closure"?

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: emacs; Severity: wishlist; Reported by: Eli Zaretskii <eliz@HIDDEN>; dated Sun, 7 Nov 2021 13:38:02 UTC; Maintainer for emacs is bug-gnu-emacs@HIDDEN.
Severity set to 'wishlist' from 'normal' Request was from Stefan Kangas <stefan@HIDDEN> to control <at> debbugs.gnu.org. Full text available.

Message received at 51661 <at> debbugs.gnu.org:


Received: (at 51661) by debbugs.gnu.org; 7 Nov 2021 22:33:38 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Nov 07 17:33:38 2021
Received: from localhost ([127.0.0.1]:55178 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1mjqjJ-0003gw-Uh
	for submit <at> debbugs.gnu.org; Sun, 07 Nov 2021 17:33:38 -0500
Received: from mailscanner.iro.umontreal.ca ([132.204.25.50]:8038)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <monnier@HIDDEN>) id 1mjqjH-0003gW-F0
 for 51661 <at> debbugs.gnu.org; Sun, 07 Nov 2021 17:33:35 -0500
Received: from pmg2.iro.umontreal.ca (localhost.localdomain [127.0.0.1])
 by pmg2.iro.umontreal.ca (Proxmox) with ESMTP id D979280570;
 Sun,  7 Nov 2021 17:33:29 -0500 (EST)
Received: from mail01.iro.umontreal.ca (unknown [172.31.2.1])
 by pmg2.iro.umontreal.ca (Proxmox) with ESMTP id 4E50D80057;
 Sun,  7 Nov 2021 17:33:28 -0500 (EST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=iro.umontreal.ca;
 s=mail; t=1636324408;
 bh=frcr/S6j2HhFwTGsKr7q/PIdMvs6iuvBO6lKMWNpTf0=;
 h=From:To:Cc:Subject:References:Date:In-Reply-To:From;
 b=ihTaz+uQOthh/hwmgD99O71uf98oBU/SYc6aYlFVuMhg/zEHluXfEIMIL0iP014l8
 BkEY9GrYD5sqUN++839RpaP+j/amaziZJpqkO6KXg/X9YMh6+5jayFXtTF5wZYJE1X
 BfCiy6B1Aa26wjOhiD/P+BP3qHyqQeF5dz2ftJCiJwKUm4IW2AnPDlc8tp+xKnGtF3
 m2vCOjOQMxtl+SIbyRBVi4hOEk/R57C3o+oORjoNAuEJ83P84s+4nXprk7EqJ+Q5Y6
 xUyq8KazdUidoiCM2V/WIyARgIbl3fhJKzXAe8RwnqNE3/NfYjeil2VD10780sY043
 SnYzTXIaoJ2Uw==
Received: from ceviche (unknown [45.72.241.23])
 by mail01.iro.umontreal.ca (Postfix) with ESMTPSA id 121C012049B;
 Sun,  7 Nov 2021 17:33:28 -0500 (EST)
From: Stefan Monnier <monnier@HIDDEN>
To: Lars Ingebrigtsen <larsi@HIDDEN>
Subject: Re: bug#51661: 29.0.50; What is "interactive Lisp closure"?
Message-ID: <jwvk0hja971.fsf-monnier+emacs@HIDDEN>
References: <83o86w84ul.fsf@HIDDEN> <87wnlkhxxx.fsf@HIDDEN>
 <83ilx483h2.fsf@HIDDEN> <87k0hkhx9t.fsf@HIDDEN>
 <86pmrbj2nk.fsf@HIDDEN> <87v913el43.fsf@HIDDEN>
Date: Sun, 07 Nov 2021 17:33:27 -0500
In-Reply-To: <87v913el43.fsf@HIDDEN> (Lars Ingebrigtsen's message of "Sun,
 07 Nov 2021 22:01:16 +0100")
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-SPAM-INFO: Spam detection results:  0
 ALL_TRUSTED                -1 Passed through trusted hosts only via SMTP
 AWL -0.062 Adjusted score from AWL reputation of From: address
 BAYES_00                 -1.9 Bayes spam probability is 0 to 1%
 DKIM_SIGNED               0.1 Message has a DKIM or DK signature,
 not necessarily valid
 DKIM_VALID -0.1 Message has at least one valid DKIM or DK signature
 DKIM_VALID_AU -0.1 Message has a valid DKIM or DK signature from author's
 domain
X-SPAM-LEVEL: 
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 51661
Cc: 51661 <at> debbugs.gnu.org, Arash Esbati <arash@HIDDEN>,
 Eli Zaretskii <eliz@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> (with-uninterpreted-text
>   (insert ";; Local Variables:
> ;; coding: utf-8
> ;; version-control: never"))

In the current case, the parsing of the `;; no-byte-compile: t` is not
done by Emacs but by the Makefile (via some grep, IIRC).


        Stefan





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#51661; Package emacs. Full text available.

Message received at 51661 <at> debbugs.gnu.org:


Received: (at 51661) by debbugs.gnu.org; 7 Nov 2021 21:01:31 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Nov 07 16:01:31 2021
Received: from localhost ([127.0.0.1]:55026 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1mjpIB-0007er-3m
	for submit <at> debbugs.gnu.org; Sun, 07 Nov 2021 16:01:31 -0500
Received: from quimby.gnus.org ([95.216.78.240]:38656)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1mjpI9-0007ec-Lb
 for 51661 <at> debbugs.gnu.org; Sun, 07 Nov 2021 16:01:30 -0500
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnus.org;
 s=20200322; h=Content-Type:MIME-Version:Message-ID:In-Reply-To:Date:
 References:Subject:Cc:To:From:Sender:Reply-To:Content-Transfer-Encoding:
 Content-ID:Content-Description:Resent-Date:Resent-From:Resent-Sender:
 Resent-To:Resent-Cc:Resent-Message-ID:List-Id:List-Help:List-Unsubscribe:
 List-Subscribe:List-Post:List-Owner:List-Archive;
 bh=/j+iSMkMibVT//jrZCYAzgmz3y2qwyyRlItp01a4iLA=; b=XAkmT1NorOVEyqVSF1aJlyLw2f
 SrX0o6DMDs+y62dJzYp6ek236CUAinDk4pbdorfg4osRtIzmjF/DCehF+Y5oNQccTDfRyoZCejC8g
 /bnPyhSPnQkgDkoNwKzUJw8kphyCZRmhiHS5QrYowFPFPhALOOZXOEOBXdMiRTtO/Tkg=;
Received: from [84.212.220.105] (helo=elva)
 by quimby.gnus.org with esmtpsa (TLS1.3:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.92) (envelope-from <larsi@HIDDEN>)
 id 1mjpHy-0003fw-U7; Sun, 07 Nov 2021 22:01:22 +0100
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Arash Esbati <arash@HIDDEN>
Subject: Re: bug#51661: 29.0.50; What is "interactive Lisp closure"?
References: <83o86w84ul.fsf@HIDDEN> <87wnlkhxxx.fsf@HIDDEN>
 <83ilx483h2.fsf@HIDDEN> <87k0hkhx9t.fsf@HIDDEN>
 <86pmrbj2nk.fsf@HIDDEN>
X-Now-Playing: Mofaya!'s _Like One Long Dream_: "Your Country"
Date: Sun, 07 Nov 2021 22:01:16 +0100
In-Reply-To: <86pmrbj2nk.fsf@HIDDEN> (Arash Esbati's message of "Sun, 07 Nov
 2021 18:28:47 +0100")
Message-ID: <87v913el43.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/29.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview:  Arash Esbati <arash@HIDDEN> writes: > you could add a ^L
 after the function (or better near eof) to prevent > Emacs from parsing that
 string as a file local variable. I tried that now, but it didn't seem to
 help. Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 51661
Cc: 51661 <at> debbugs.gnu.org, Eli Zaretskii <eliz@HIDDEN>,
 Stefan Monnier <monnier@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

Arash Esbati <arash@HIDDEN> writes:

> you could add a ^L after the function (or better near eof) to prevent
> Emacs from parsing that string as a file local variable.

I tried that now, but it didn't seem to help.

We really need a general "this thing here shouldn't be interpreted by
any of the things that look for this stuff" mechanism.  But I'm not sure
what that would look like.

(with-uninterpreted-text
  (insert ";; Local Variables:
;; coding: utf-8
;; version-control: never"))

or something?  The code that's looking for these things are pretty
simple, though, and would have to be made more complicated, which is a
downside.

Stefan M's solution (use \s instead of space) is probably the best.

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#51661; Package emacs. Full text available.

Message received at 51661 <at> debbugs.gnu.org:


Received: (at 51661) by debbugs.gnu.org; 7 Nov 2021 17:29:22 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Nov 07 12:29:21 2021
Received: from localhost ([127.0.0.1]:54561 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1mjlyr-00069J-Kr
	for submit <at> debbugs.gnu.org; Sun, 07 Nov 2021 12:29:21 -0500
Received: from eggs.gnu.org ([209.51.188.92]:54618)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <arash@HIDDEN>) id 1mjlym-000692-3G
 for 51661 <at> debbugs.gnu.org; Sun, 07 Nov 2021 12:29:20 -0500
Received: from [2001:470:142:3::e] (port=51144 helo=fencepost.gnu.org)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <arash@HIDDEN>)
 id 1mjlyf-0003li-LV; Sun, 07 Nov 2021 12:29:09 -0500
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnu.org;
 s=fencepost-gnu-org; h=MIME-Version:In-Reply-To:Date:References:Subject:To:
 From; bh=hHwFDv/Yty8kZ9VaO/KoB/HeDjdTtyzAvvbIGT6yzDg=; b=oRE3oExq4tp7AMYjMRBo
 C12hBsdbLJ4kQCcWTrE6OJTot8Tf/zwiHM2EWuar0TYi0XHTAqSpnci1bqp7xOYpEYM4SG06dXABU
 EoOqCYsfjNpj8Dj5LE8u7ZAJXbhinVB/Cn+sTO1oEt44xJXYUtLgxehCcPnFW2jQLsR7vs3qrm6tN
 yZ5E89yXxvn29oDGiv3aP4pMVCDB3WWZJoXbBcDFYMvu9NxIaPpJ4IOWp1lHfpzeicJNE/9TIwUoS
 qjTGxiGlwmOIhivd65tJneMcw4Hx0Vsic6PnCaBTD273P9bRzO2YkqfT25g+B6SkgRYIt4GwhLB9O
 MRO9/k4NBZs/mQ==;
Received: from p5b326965.dip0.t-ipconnect.de ([91.50.105.101]:55118
 helo=MUTANT)
 by fencepost.gnu.org with esmtpsa (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <arash@HIDDEN>)
 id 1mjlyf-0003Uh-7Y; Sun, 07 Nov 2021 12:29:09 -0500
From: Arash Esbati <arash@HIDDEN>
To: Lars Ingebrigtsen <larsi@HIDDEN>
Subject: Re: bug#51661: 29.0.50; What is "interactive Lisp closure"?
References: <83o86w84ul.fsf@HIDDEN> <87wnlkhxxx.fsf@HIDDEN>
 <83ilx483h2.fsf@HIDDEN> <87k0hkhx9t.fsf@HIDDEN>
Date: Sun, 07 Nov 2021 18:28:47 +0100
In-Reply-To: <87k0hkhx9t.fsf@HIDDEN> (Lars Ingebrigtsen's message of "Sun,
 07 Nov 2021 15:10:22 +0100")
Message-ID: <86pmrbj2nk.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/29.0.50
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 51661
Cc: 51661 <at> debbugs.gnu.org, Eli Zaretskii <eliz@HIDDEN>,
 Stefan Monnier <monnier@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

Lars Ingebrigtsen <larsi@HIDDEN> writes:

> Eli Zaretskii <eliz@HIDDEN> writes:
>
>> No.  But emoji.el says this:
>>
>>       (insert ";; Local" " Variables:
>>   ;; coding: utf-8
>>   ;; version-control: never
>>   ;; no-byte-compile: t
>>   ;; no-update-autoloads: t
>>   ;; End:
>>
>>   (provide 'emoji-labels)
>>
>> and that trips the 'compile-main' target in lisp/Makefile to think
>> this file should not be byte-compiled.
>
> D'oh.  I thought my obfuscation there was sufficient.  I'll get fixing.

you could add a ^L after the function (or better near eof) to prevent
Emacs from parsing that string as a file local variable.  It might be
more clear than further obfuscation (as in 42fd5f2789).

Best, Arash




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#51661; Package emacs. Full text available.

Message received at 51661 <at> debbugs.gnu.org:


Received: (at 51661) by debbugs.gnu.org; 7 Nov 2021 14:19:06 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Nov 07 09:19:06 2021
Received: from localhost ([127.0.0.1]:52158 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1mjj0k-0004iO-0t
	for submit <at> debbugs.gnu.org; Sun, 07 Nov 2021 09:19:06 -0500
Received: from mail-out.m-online.net ([212.18.0.10]:38439)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <whitebox@HIDDEN>) id 1mjj0g-0004hT-Fv
 for 51661 <at> debbugs.gnu.org; Sun, 07 Nov 2021 09:19:04 -0500
Received: from frontend01.mail.m-online.net (unknown [192.168.8.182])
 by mail-out.m-online.net (Postfix) with ESMTP id 4HnGZY3HGBz1rk5m;
 Sun,  7 Nov 2021 15:19:01 +0100 (CET)
Received: from localhost (dynscan1.mnet-online.de [192.168.6.70])
 by mail.m-online.net (Postfix) with ESMTP id 4HnGZY0tGtz1qqkD;
 Sun,  7 Nov 2021 15:19:01 +0100 (CET)
X-Virus-Scanned: amavisd-new at mnet-online.de
Received: from mail.mnet-online.de ([192.168.8.182])
 by localhost (dynscan1.mail.m-online.net [192.168.6.70]) (amavisd-new,
 port 10024)
 with ESMTP id 7DCCl_j_WqXq; Sun,  7 Nov 2021 15:19:00 +0100 (CET)
X-Auth-Info: QP4JvjpA+HgNipqIdhsjZv1AWBlpz8H0VpSUZZrmqlUSbAQU4U2mDa4N09bg7RJv
Received: from igel.home (ppp-46-244-179-28.dynamic.mnet-online.de
 [46.244.179.28])
 (using TLSv1.2 with cipher ECDHE-RSA-AES256-GCM-SHA384 (256/256 bits))
 (No client certificate requested)
 by mail.mnet-online.de (Postfix) with ESMTPSA;
 Sun,  7 Nov 2021 15:19:00 +0100 (CET)
Received: by igel.home (Postfix, from userid 1000)
 id D637F2C12D4; Sun,  7 Nov 2021 15:18:59 +0100 (CET)
From: Andreas Schwab <schwab@HIDDEN>
To: Lars Ingebrigtsen <larsi@HIDDEN>
Subject: Re: bug#51661: 29.0.50; What is "interactive Lisp closure"?
References: <83o86w84ul.fsf@HIDDEN> <87wnlkhxxx.fsf@HIDDEN>
X-Yow: ONE:  I will donate my entire ``BABY HUEY'' comic book collection
 to the downtown PLASMA CENTER..
 TWO:  I won't START a BAND called ``KHADAFY & THE HIT SQUAD''..
 THREE:  I won't ever TUMBLE DRY my FOX TERRIER again!!
Date: Sun, 07 Nov 2021 15:18:59 +0100
In-Reply-To: <87wnlkhxxx.fsf@HIDDEN> (Lars Ingebrigtsen's message of "Sun,
 07 Nov 2021 14:55:54 +0100")
Message-ID: <87zgqgkq0c.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.2 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.5 (/)
X-Debbugs-Envelope-To: 51661
Cc: 51661 <at> debbugs.gnu.org, Eli Zaretskii <eliz@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.5 (-)

On Nov 07 2021, Lars Ingebrigtsen wrote:

> I think that's because your emoji.el isn't byte-compiled?  Hm...  mine's
> not byte-compiled either?  Do we have to add some incantation somewhere
> to get newly-added .el files to be byte-compiled?

Remove ";; no-byte-compile: t" from the file.

Andreas.

-- 
Andreas Schwab, schwab@HIDDEN
GPG Key fingerprint = 7578 EB47 D4E5 4D69 2510  2552 DF73 E780 A9DA AEC1
"And now for something completely different."




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#51661; Package emacs. Full text available.

Message received at 51661 <at> debbugs.gnu.org:


Received: (at 51661) by debbugs.gnu.org; 7 Nov 2021 14:10:35 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Nov 07 09:10:35 2021
Received: from localhost ([127.0.0.1]:52140 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1mjisU-0004TZ-Nh
	for submit <at> debbugs.gnu.org; Sun, 07 Nov 2021 09:10:34 -0500
Received: from quimby.gnus.org ([95.216.78.240]:35514)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1mjisT-0004TM-94
 for 51661 <at> debbugs.gnu.org; Sun, 07 Nov 2021 09:10:33 -0500
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnus.org;
 s=20200322; h=Content-Type:MIME-Version:Message-ID:In-Reply-To:Date:
 References:Subject:Cc:To:From:Sender:Reply-To:Content-Transfer-Encoding:
 Content-ID:Content-Description:Resent-Date:Resent-From:Resent-Sender:
 Resent-To:Resent-Cc:Resent-Message-ID:List-Id:List-Help:List-Unsubscribe:
 List-Subscribe:List-Post:List-Owner:List-Archive;
 bh=1p7EpMIuFx7HtuzjG9idlktYeTEQzrGU/vUK3Hjm90c=; b=IpJ8ZD+/uMuQnwobUHGk2cZZtP
 OlcnByD4hGdzgHh/TV9TlQ836fm+7sJr1vCcIUyXm8IyCkFw9B9H5d/1iqlPhZWcC/0c8mNJNEzRt
 CJmN2auLoDwzOndbaUNnl0eZx4ceP0BmsFG8bSahCHi9GElhXCUvUi0gkp8AFVmJGPB8=;
Received: from [84.212.220.105] (helo=elva)
 by quimby.gnus.org with esmtpsa (TLS1.3:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.92) (envelope-from <larsi@HIDDEN>)
 id 1mjisI-0000wf-Oq; Sun, 07 Nov 2021 15:10:25 +0100
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#51661: 29.0.50; What is "interactive Lisp closure"?
References: <83o86w84ul.fsf@HIDDEN> <87wnlkhxxx.fsf@HIDDEN>
 <83ilx483h2.fsf@HIDDEN>
Face: iVBORw0KGgoAAAANSUhEUgAAADAAAAAwBAMAAAClLOS0AAAABGdBTUEAALGPC/xhBQAAACBj
 SFJNAAB6JgAAgIQAAPoAAACA6AAAdTAAAOpgAAA6mAAAF3CculE8AAAAGFBMVEX9/f22rp00Lyne
 2tNqYVKgkXOFeGH///+tuyR9AAAAAWJLR0QHFmGI6wAAAAd0SU1FB+ULBw0tNocSdRwAAAGnSURB
 VDjLvZMxd+MgDMflR2+vnDjznY7zDCXuHiIzG8d4bvug3/8jnOy+W/LI0OW0GPRDSNZfANStBXVw
 iM6iPdyBZuSRj5n5dgdAmfpVD3N8HzxX/XaGVM0dPXRTxa/QA95qwEnEoQasRFSB8nDYk3f4Vd0w
 xm3vFEFy295Tj+KxmT57+WJDgJ2BRnsifQW1LjnTb4CEAo7P+MRM7AMMOa6j//NkYvDQ0hsvOoQT
 a9MVM6Q5eIzag9esR+JgM0/dTX7tozDnHSx69Hy1XZpepcRG4tkLoJ655/4dcZ0GAcM463LeQOLs
 +5Ai8mSjw3MJVFoBGqPkHWNctLEnl3xZdJq3iMuysmYOWYMaYqbxNK476HNivXriC6jGM4VScO5J
 qkqBAxMFEeYHjQsxl2PvYeBya+UgaelZU9CTduuqSfr2Sw72TNdduYVk0URP4M4/pbvvy+VLCK9l
 oYoAY3fR3T+JdnnSpwdnK2PyepnBuQqwpgVjKsBs78M9ANWrttl1tfHZgav5nSSHb4HHD+flv4Mu
 4nDrEBNOdxFOKeM2My/g6tYCPbC/0VxlXj9W7vUAAAAldEVYdGRhdGU6Y3JlYXRlADIwMjEtMTEt
 MDdUMTM6NDU6NTQrMDA6MDCeUl5QAAAAJXRFWHRkYXRlOm1vZGlmeQAyMDIxLTExLTA3VDEzOjQ1
 OjU0KzAwOjAw7w/m7AAAAABJRU5ErkJggg==
X-Now-Playing: Sleater-Kinney's _Path of Wellness_: "Tomorrows Grave"
Date: Sun, 07 Nov 2021 15:10:22 +0100
In-Reply-To: <83ilx483h2.fsf@HIDDEN> (Eli Zaretskii's message of "Sun, 07 Nov
 2021 16:06:33 +0200")
Message-ID: <87k0hkhx9t.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/29.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview: Eli Zaretskii <eliz@HIDDEN> writes: > No. But emoji.el says
 this: > > (insert "; ; Local" " Variables: > ; ; coding: utf-8 > ; ;
 version-control:
 never > ; ; no-byte-compile: t > ; ; no-update-autoloads: t > ; ;
 End: > > (provide 'emoji-label [...] 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 51661
Cc: 51661 <at> debbugs.gnu.org, Stefan Monnier <monnier@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

Eli Zaretskii <eliz@HIDDEN> writes:

> No.  But emoji.el says this:
>
>       (insert ";; Local" " Variables:
>   ;; coding: utf-8
>   ;; version-control: never
>   ;; no-byte-compile: t
>   ;; no-update-autoloads: t
>   ;; End:
>
>   (provide 'emoji-labels)
>
> and that trips the 'compile-main' target in lisp/Makefile to think
> this file should not be byte-compiled.

D'oh.  I thought my obfuscation there was sufficient.  I'll get fixing.

> I think we should replace "closure" by "function" in the Help buffer.
> There's no need to show this to users.

Let's see...  it's this code?  I'm guessing Stefan M wrote this, so I'm
adding him to the CCs.

(defun help-fns-function-description-header (function)
  "Print a line describing FUNCTION to `standard-output'."
  (pcase-let* ((`(,_real-function ,def ,aliased ,real-def)
                (help-fns--analyze-function function))
               (file-name (find-lisp-object-file-name function (if aliased 'defun
                                                                 def)))
               (beg (if (and (or (byte-code-function-p def)
                                 (keymapp def)
                                 (memq (car-safe def) '(macro lambda closure)))
                             (stringp file-name)
                             (help-fns--autoloaded-p function file-name))
                        (concat
                         "an autoloaded " (if (commandp def)
                                              "interactive "))
                      (if (commandp def) "an interactive " "a "))))

I don't really have an opinion.  I agree that "closure"/"lambda" here is
probably more information than most users have asked for, but on the
other hand, it's a reality, so how much of the details should we hide?

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#51661; Package emacs. Full text available.

Message received at 51661 <at> debbugs.gnu.org:


Received: (at 51661) by debbugs.gnu.org; 7 Nov 2021 14:06:57 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Nov 07 09:06:57 2021
Received: from localhost ([127.0.0.1]:52136 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1mjioz-0004Nv-5c
	for submit <at> debbugs.gnu.org; Sun, 07 Nov 2021 09:06:57 -0500
Received: from eggs.gnu.org ([209.51.188.92]:57694)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1mjiou-0004Ng-An
 for 51661 <at> debbugs.gnu.org; Sun, 07 Nov 2021 09:06:55 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:45508)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>)
 id 1mjiop-0003RB-3r; Sun, 07 Nov 2021 09:06:47 -0500
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnu.org;
 s=fencepost-gnu-org; h=MIME-version:References:Subject:In-Reply-To:To:From:
 Date; bh=xR0fbmytbghcwTk6FmCuTkyZN7xPL7/ZPzUrUjrs+Lk=; b=RYHuHhUP/K/BRPPdeS+w
 G9dQWmir17q/BpX44t9DegfMGDE4Kad3ZnHGrBiIuvtIPXA6pxU8HnqrLRsVp6W35YeGigQNzg/Ee
 S4JKKkag3wHUfNgdVK+fRMhypzy6KttuLE5kzzffvkFu7kvcbefeIwU7G81VLD4SnDKtnQzVTvSCH
 A65VA/8st9SkuBU9TmkVHKgf1aXZgTlXusSSPt7gngTbr7QFSPxx01ZpqGxlLFdh860pvqRI6CWeQ
 ldeyfT+s85hCNrDtBJSsHFW14DAZsN747Ks0//LzT4ddktUXqe4IgTFupNt5QPeZRw1pQPpCRQAb2
 gJhZvFIkla0NEw==;
Received: from [87.69.77.57] (port=2574 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>)
 id 1mjioo-000868-Md; Sun, 07 Nov 2021 09:06:47 -0500
Date: Sun, 07 Nov 2021 16:06:33 +0200
Message-Id: <83ilx483h2.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Lars Ingebrigtsen <larsi@HIDDEN>
In-Reply-To: <87wnlkhxxx.fsf@HIDDEN> (message from Lars Ingebrigtsen on Sun, 
 07 Nov 2021 14:55:54 +0100)
Subject: Re: bug#51661: 29.0.50; What is "interactive Lisp closure"?
References: <83o86w84ul.fsf@HIDDEN> <87wnlkhxxx.fsf@HIDDEN>
MIME-version: 1.0
Content-type: text/plain; charset=utf-8
Content-Transfer-Encoding: 8bit
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 51661
Cc: 51661 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Lars Ingebrigtsen <larsi@HIDDEN>
> Cc: 51661 <at> debbugs.gnu.org
> Date: Sun, 07 Nov 2021 14:55:54 +0100
> 
> Eli Zaretskii <eliz@HIDDEN> writes:
> 
> > To reproduce:
> >
> >   emacs -Q
> >   C-h f emoji-insert RET
> >
> > This says:
> >
> >   emoji-insert is an autoloaded interactive Lisp closure in ‘emoji.el’.
> >
> > Other commands still say "interactive compiled Lisp function", at
> > least the few I tried did.
> 
> I think that's because your emoji.el isn't byte-compiled?  Hm...  mine's
> not byte-compiled either?  Do we have to add some incantation somewhere
> to get newly-added .el files to be byte-compiled?

No.  But emoji.el says this:

      (insert ";; Local" " Variables:
  ;; coding: utf-8
  ;; version-control: never
  ;; no-byte-compile: t
  ;; no-update-autoloads: t
  ;; End:

  (provide 'emoji-labels)

and that trips the 'compile-main' target in lisp/Makefile to think
this file should not be byte-compiled.

> > Is this the same "closure"?
> 
> Yes.
> 
> > What is special about this command that we say "closure" there?  Do we
> > have to confuse users by showing that in the Help buffers?
> 
> C-h f will say that about all uncompiled functions that use lexical
> binding, I think?  So there's nothing special about it.  (If it didn't
> use lexical binding it'd say "lambda" instead of "closure", I guess.)
> 
> I have no opinion on whether this distinction (lambda/closure) is
> meaningful to expose to the user in `C-h f'.

I think we should replace "closure" by "function" in the Help buffer.
There's no need to show this to users.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#51661; Package emacs. Full text available.

Message received at 51661 <at> debbugs.gnu.org:


Received: (at 51661) by debbugs.gnu.org; 7 Nov 2021 13:56:06 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Nov 07 08:56:06 2021
Received: from localhost ([127.0.0.1]:52125 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1mjieT-00045R-NL
	for submit <at> debbugs.gnu.org; Sun, 07 Nov 2021 08:56:06 -0500
Received: from quimby.gnus.org ([95.216.78.240]:35308)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1mjieS-000451-9O
 for 51661 <at> debbugs.gnu.org; Sun, 07 Nov 2021 08:56:04 -0500
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnus.org;
 s=20200322; h=Content-Transfer-Encoding:Content-Type:MIME-Version:Message-ID
 :In-Reply-To:Date:References:Subject:Cc:To:From:Sender:Reply-To:Content-ID:
 Content-Description:Resent-Date:Resent-From:Resent-Sender:Resent-To:Resent-Cc
 :Resent-Message-ID:List-Id:List-Help:List-Unsubscribe:List-Subscribe:
 List-Post:List-Owner:List-Archive;
 bh=9xYVpKr23ICok3nuif8+m/Uk8wSO3hL7sqQRP1wILco=; b=Dsx5Tw/iDJ4NaYp8p1l9V665Mi
 4ayX5EkrXQ0prJ+P4x0mA1dmvUoduGJ4sZ/MAhA15HP3vzB0JowjBQKWX4ISVaasjmOcB22a21/am
 LAmM0Msliqri+qwYm8mqCt+mNmZhjWscc9WTaqVMf8c97Atak4/o6wwv7UE8hkNaeyQ4=;
Received: from [84.212.220.105] (helo=elva)
 by quimby.gnus.org with esmtpsa (TLS1.3:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.92) (envelope-from <larsi@HIDDEN>)
 id 1mjieJ-0000rF-F8; Sun, 07 Nov 2021 14:55:58 +0100
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#51661: 29.0.50; What is "interactive Lisp closure"?
References: <83o86w84ul.fsf@HIDDEN>
Face: iVBORw0KGgoAAAANSUhEUgAAADAAAAAwBAMAAAClLOS0AAAABGdBTUEAALGPC/xhBQAAACBj
 SFJNAAB6JgAAgIQAAPoAAACA6AAAdTAAAOpgAAA6mAAAF3CculE8AAAAGFBMVEX9/f22rp00Lyne
 2tNqYVKgkXOFeGH///+tuyR9AAAAAWJLR0QHFmGI6wAAAAd0SU1FB+ULBw0tNocSdRwAAAGnSURB
 VDjLvZMxd+MgDMflR2+vnDjznY7zDCXuHiIzG8d4bvug3/8jnOy+W/LI0OW0GPRDSNZfANStBXVw
 iM6iPdyBZuSRj5n5dgdAmfpVD3N8HzxX/XaGVM0dPXRTxa/QA95qwEnEoQasRFSB8nDYk3f4Vd0w
 xm3vFEFy295Tj+KxmT57+WJDgJ2BRnsifQW1LjnTb4CEAo7P+MRM7AMMOa6j//NkYvDQ0hsvOoQT
 a9MVM6Q5eIzag9esR+JgM0/dTX7tozDnHSx69Hy1XZpepcRG4tkLoJ655/4dcZ0GAcM463LeQOLs
 +5Ai8mSjw3MJVFoBGqPkHWNctLEnl3xZdJq3iMuysmYOWYMaYqbxNK476HNivXriC6jGM4VScO5J
 qkqBAxMFEeYHjQsxl2PvYeBya+UgaelZU9CTduuqSfr2Sw72TNdduYVk0URP4M4/pbvvy+VLCK9l
 oYoAY3fR3T+JdnnSpwdnK2PyepnBuQqwpgVjKsBs78M9ANWrttl1tfHZgav5nSSHb4HHD+flv4Mu
 4nDrEBNOdxFOKeM2My/g6tYCPbC/0VxlXj9W7vUAAAAldEVYdGRhdGU6Y3JlYXRlADIwMjEtMTEt
 MDdUMTM6NDU6NTQrMDA6MDCeUl5QAAAAJXRFWHRkYXRlOm1vZGlmeQAyMDIxLTExLTA3VDEzOjQ1
 OjU0KzAwOjAw7w/m7AAAAABJRU5ErkJggg==
X-Now-Playing: Sleater-Kinney's _Path of Wellness_: "Worry With You"
Date: Sun, 07 Nov 2021 14:55:54 +0100
In-Reply-To: <83o86w84ul.fsf@HIDDEN> (Eli Zaretskii's message of "Sun, 07 Nov
 2021 15:36:50 +0200")
Message-ID: <87wnlkhxxx.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/29.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 
 Content preview:  Eli Zaretskii <eliz@HIDDEN> writes: > To reproduce: > > emacs
    -Q > C-h f emoji-insert RET > > This says: > > emoji-insert is an autoloaded
    interactive Lisp closure in ‘emoji.el’. > > Other commands still say
   "interactive compiled Li [...] 
 
 Content analysis details:   (-2.9 points, 5.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
                             [score: 0.0000]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 51661
Cc: 51661 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

Eli Zaretskii <eliz@HIDDEN> writes:

> To reproduce:
>
>   emacs -Q
>   C-h f emoji-insert RET
>
> This says:
>
>   emoji-insert is an autoloaded interactive Lisp closure in =E2=80=98emoj=
i.el=E2=80=99.
>
> Other commands still say "interactive compiled Lisp function", at
> least the few I tried did.

I think that's because your emoji.el isn't byte-compiled?  Hm...  mine's
not byte-compiled either?  Do we have to add some incantation somewhere
to get newly-added .el files to be byte-compiled?

> Is this the same "closure"?

Yes.

> What is special about this command that we say "closure" there?  Do we
> have to confuse users by showing that in the Help buffers?

C-h f will say that about all uncompiled functions that use lexical
binding, I think?  So there's nothing special about it.  (If it didn't
use lexical binding it'd say "lambda" instead of "closure", I guess.)

I have no opinion on whether this distinction (lambda/closure) is
meaningful to expose to the user in `C-h f'.

--=20
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#51661; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 7 Nov 2021 13:37:07 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Nov 07 08:37:06 2021
Received: from localhost ([127.0.0.1]:52077 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1mjiM6-0001Nx-Gd
	for submit <at> debbugs.gnu.org; Sun, 07 Nov 2021 08:37:06 -0500
Received: from lists.gnu.org ([209.51.188.17]:58912)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1mjiM3-0001Nn-N7
 for submit <at> debbugs.gnu.org; Sun, 07 Nov 2021 08:37:04 -0500
Received: from eggs.gnu.org ([2001:470:142:3::10]:49758)
 by lists.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>) id 1mjiM3-00048F-H4
 for bug-gnu-emacs@HIDDEN; Sun, 07 Nov 2021 08:37:03 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:44746)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>) id 1mjiM3-0004ly-92
 for bug-gnu-emacs@HIDDEN; Sun, 07 Nov 2021 08:37:03 -0500
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnu.org;
 s=fencepost-gnu-org; h=MIME-version:Subject:To:From:Date:in-reply-to:
 references; bh=wHSYgbeeX2NME/fNUrdJ3jewJgXGn9iFAS5AHPdauPw=; b=ZAqpBfvQzc0AgD
 S+mzdvyyLkKtSrJgr9aTQF5oktjJSfFs4rtoWXNnATxG5lScsc0TpFUtS1/ZfrEHoUkaLB1uloGBE
 fsqlVYfrCq5CoMnqULvD+dQclVGjpCZVUUt2Dcd+9zpF2tqjgaYW9FT4q9wJLXYsh2Y2K6FZy7Hk9
 rE2gQsgaNr8RpyoGqeHB9GVh915IGFa2ACbDeLRp11S0+a6/21rRpu8JvsrOWA4g4iF+Zeaiio1rp
 zkKKWYCAsNIB9Cv55kKcgmXhCbCyZbgvxwEDxiIhG0VD9RJssA10naFIN7eWtMGBMRegVqcx1xiKb
 ElFWhbCPGvu3AxN0TUMA==;
Received: from [87.69.77.57] (port=4727 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>) id 1mjiM2-0002j5-SU
 for bug-gnu-emacs@HIDDEN; Sun, 07 Nov 2021 08:37:03 -0500
Date: Sun, 07 Nov 2021 15:36:50 +0200
Message-Id: <83o86w84ul.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: bug-gnu-emacs@HIDDEN
Subject: 29.0.50; What is "interactive Lisp closure"?
MIME-version: 1.0
Content-type: text/plain; charset=utf-8
Content-Transfer-Encoding: 8bit
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

To reproduce:

  emacs -Q
  C-h f emoji-insert RET

This says:

  emoji-insert is an autoloaded interactive Lisp closure in ‘emoji.el’.

Other commands still say "interactive compiled Lisp function", at
least the few I tried did.

What is "an autoloaded interactive Lisp closure"?  There's no mention
of it in the Emacs user manual, and the Emacs Lisp Reference manual
says this about closures:

     A closure is a function that also carries a record of the lexical
  environment that existed when the function was defined.  When it is
  invoked, any lexical variable references within its definition use the
  retained lexical environment.  In all other respects, closures behave
  much like ordinary functions; in particular, they can be called in the
  same way as ordinary functions.

Is this the same "closure"?  What is special about this command that
we say "closure" there?  Do we have to confuse users by showing that
in the Help buffers?

In GNU Emacs 29.0.50 (build 137, i686-pc-mingw32)
 of 2021-11-07 built on HOME-C4E4A596F7
Repository revision: a05f6bb6718a6ba2617d367e665d6f658a518448
Repository branch: master
Windowing system distributor 'Microsoft Corp.', version 5.1.2600
System Description: Microsoft Windows XP Service Pack 3 (v5.1.0.2600)

Configured using:
 'configure -C --prefix=/d/usr --with-wide-int
 --enable-checking=yes,glyphs 'CFLAGS=-O0 -gdwarf-4 -g3''

Configured features:
ACL GIF GMP GNUTLS HARFBUZZ JPEG JSON LCMS2 LIBXML2 MODULES NOTIFY
W32NOTIFY PDUMPER PNG RSVG SOUND THREADS TIFF TOOLKIT_SCROLL_BARS WEBP
XPM ZLIB

Important settings:
  value of $LANG: ENU
  locale-coding-system: cp1255

Major mode: ELisp/l

Minor modes in effect:
  bug-reference-prog-mode: t
  tooltip-mode: t
  global-eldoc-mode: t
  eldoc-mode: t
  show-paren-mode: t
  electric-indent-mode: t
  mouse-wheel-mode: t
  tool-bar-mode: t
  menu-bar-mode: t
  file-name-shadow-mode: t
  global-font-lock-mode: t
  font-lock-mode: t
  blink-cursor-mode: t
  auto-composition-mode: t
  auto-encryption-mode: t
  auto-compression-mode: t
  line-number-mode: t
  transient-mark-mode: t

Load-path shadows:
None found.

Features:
(shadow sort mail-extr emacsbug message mailcap yank-media rmc puny
dired dired-loaddefs rfc822 mml mml-sec epa epg rfc6068 epg-config
gnus-util rmail rmail-loaddefs auth-source password-cache json map
time-date mm-decode mm-bodies mm-encode mail-parse rfc2231 mailabbrev
gmm-utils mailheader sendmail rfc2047 rfc2045 ietf-drums mm-util
mail-prsvr mail-utils vc-git diff-mode easy-mmode vc-dispatcher
bug-reference shortdoc text-property-search eieio-opt speedbar ezimage
dframe find-func emoji pcase derived transient cl-seq format-spec
edmacro kmacro eieio eieio-core cl-macs eieio-loaddefs cl-extra seq gv
subr-x byte-opt bytecomp byte-compile cconv thingatpt help-fns
radix-tree help-mode cl-loaddefs cl-lib iso-transl tooltip eldoc paren
electric uniquify ediff-hook vc-hooks lisp-float-type elisp-mode mwheel
dos-w32 ls-lisp disp-table term/w32-win w32-win w32-vars term/common-win
tool-bar dnd fontset image regexp-opt fringe tabulated-list replace
newcomment text-mode lisp-mode prog-mode register page tab-bar menu-bar
rfn-eshadow isearch easymenu timer select scroll-bar mouse jit-lock
font-lock syntax font-core term/tty-colors frame minibuffer cl-generic
cham georgian utf-8-lang misc-lang vietnamese tibetan thai tai-viet lao
korean japanese eucjp-ms cp51932 hebrew greek romanian slovak czech
european ethiopic indian cyrillic chinese composite emoji-zwj charscript
charprop case-table epa-hook jka-cmpr-hook help simple abbrev obarray
cl-preloaded nadvice button loaddefs faces cus-face macroexp files
window text-properties overlay sha1 md5 base64 format env code-pages
mule custom widget hashtable-print-readable backquote threads w32notify
w32 lcms2 multi-tty make-network-process emacs)

Memory information:
((conses 16 89759 6808)
 (symbols 48 9892 1)
 (strings 16 31319 2890)
 (string-bytes 1 870273)
 (vectors 16 18283)
 (vector-slots 8 232402 11964)
 (floats 8 78 46)
 (intervals 40 554 168)
 (buffers 888 13))




Acknowledgement sent to Eli Zaretskii <eliz@HIDDEN>:
New bug report received and forwarded. Copy sent to bug-gnu-emacs@HIDDEN. Full text available.
Report forwarded to bug-gnu-emacs@HIDDEN:
bug#51661; Package emacs. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Wed, 10 Nov 2021 02:15:01 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.